{#if opened}
<div in:slide="{duration:100}"
     class="presence-switcher">
  {#each presenceKeys as presenceKey}
  <div on:click="setPresence($userId, presenceKey)"
       class="presence-choice">
    <span class="presence-name">
      {presenceKey}
    </span>
    <span class="presence-indicator"
          class:offline="presenceKey == 'offline'"
          class:dnd="presenceKey == 'dnd'"
          class:idle="presenceKey == 'idle'"
          class:online="presenceKey == 'online'">
      <PresencePointer noCorner={true} presence={lookup(presenceKey)} />
    </span>
  </div>
  {/each}
</div>
{/if}

<div class="user-preview">
  <div
    on:click="set({opened: !opened})"
    style={avatarUrl && `background-image:url(${avatarUrl})`}
    class="avatar">
    <PresencePointer {presence} />
  </div>
  <span class="username">
    {username}
  </span>
  <span class="action-icon user-settings-action" on:click="openSettings({username, avatar, id: $userId})">
    <SettingsIcon />
  </span>
</div>

<script>
  import SettingsIcon from "./icons/SettingsIcon.svelte";
  import env from "../js/constants";
  import UserSettingsModal from "./modals/UserSettingsModal.svelte";
  import UserStore from "../stores/UserStore";
  import RealTimeClient from "../js/RealTimeClient";
  import slide from "svelte-transitions-slide";
  import constants from "../js/constants";

  export default {
    transitions: {
      slide
    },
    helpers: {
      lookup(key) {
        return env.presence[key];
      },
      presenceKeys: Object.keys(env.presence)
    },
    components: {
      SettingsIcon,
      PresencePointer: "./PresencePointer.svelte"
    },
    methods: {
      setPresence(userId, presenceKey) {
        const presence = constants.presence[presenceKey];
        const user = UserStore.getItem(userId);
        RealTimeClient.setPresence(presence, (user && user.activity) || null);
        localStorage.lastPresence = presence;
        this.set({opened: false});
      },
      openSettings(user) {
        this.store.set({
          modal: {
            component: UserSettingsModal,
            options: user
          }
        });
      },
      async userChange() {
        console.log("USERCHANGED! CURRENT USER");
        const user = UserStore.getItem(this.get().userId);
        this.set({
          username: user && user.username,
          avatar: user && user.avatar,
          presence: user && user.presence
        });
      }
    },
    onstate({current, changed}) {
      if (changed.userId) {
        UserStore.subscribeComponent(current.userId, this, this.userChange, "u");
      }
    },
    computed: {
      userId({$userId}) {
        return $userId;
      },
      avatarUrl({$userId, avatar}) {
        return avatar ? `${env.API_BASE}/avatars/${$userId}/${avatar}` : null;
      }
    }
  };
</script>

<style>
  .action-icon {
    margin-top: calc((2em - 20px) / 2);
    cursor: pointer;
    float: right;
  }

  .user-preview {
    padding: 1em 0.5em;
    border-top: solid 1px #2f3336;
    background-color: #202224;
    display: flex;
  }

  .avatar {
    position: relative;
    border-radius: 100%;
    height: 2em;
    width: 2em;
    background-color: #1d1d1d;
    cursor: pointer;
    background-size: contain;
    display: inline-block;
  }
  .username {
    line-height: 2em;
    vertical-align: top;
    flex: 1;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
    margin-left: 0.5em;
  }
  .presence-switcher.closed {
    display: none;
  }
  .presence-switcher {
    background: #202224;
    border-radius: 5px;
    border: 1px #151515 solid;
    box-shadow: 0 2px 3px #11111110;
    margin: 0.25em;
  }
  .presence-choice {
    display: flex;
    flex-direction: row;
    padding: 1em 0.5em;
  }
  .presence-choice:first-child {
    border-top-left-radius: 5px;
    border-top-right-radius: 5px;
  }
  .presence-choice:last-child {
    border-bottom-left-radius: 5px;
    border-bottom-right-radius: 5px;
  }
  .presence-choice:hover {
    background: #101112;
    cursor: pointer;
  }

  .presence-indicator {
    height: 0.75em;
    width: 0.75em;
    border-radius: 100%;
    display: inline-block;
    flex-shrink: 0;
    flex-grow: 0;
    margin-top: auto;
    margin-bottom: auto;
  }

  .presence-name {
    color: #ddd;
    flex-grow: 1;
    flex-shrink: 1;
  }

  .presence-indicator.dnd {
    background: #f04747;
  }
  .presence-indicator.online {
    background: #43b581;
  }
  .presence-indicator.offline {
    background: #747f8d;
  }
  .presence-indicator.idle {
    background: #faa61a;
  }
</style>
